#version 140

// Precision qualifier
precision highp float;

// Attributs
in vec3 tangent;
in vec4 vertex;
in vec3 normal;
in vec2 MultiTexCoord0;

// Uniform
uniform mat3 NormalMatrix;
uniform mat4 ProjectionMatrix;
uniform mat4 ModelViewMatrix;

// Sorties
smooth out vec3 EyeVector, Normal, LightDir;
smooth out vec2 fragmentTexCoord;

invariant gl_Position;

void main ()
{
	fragmentTexCoord = MultiTexCoord0;

	Normal = NormalMatrix * normal;
	vec3 Position = vec3( ModelViewMatrix * vertex);

	LightDir = vec3( 0.0, 0.0, -1.0) - Position;
	EyeVector = -Position;
	
	gl_Position = ProjectionMatrix * ModelViewMatrix * vertex;
}