#version 140

in vec3 tangent;
in vec4 vertex;
in vec3 normal;

layout(std140) uniform in_Material
{
	vec4 in_MatAmbient;
	vec4 in_MatDiffuse;
	vec4 in_MatEmissive;
	vec4 in_MatSpecular;
	float in_MatShininess;
};

uniform mat4 ProjectionMatrix;
uniform mat4 ModelViewMatrix;
uniform mat3 NormalMatrix;

out vec4 ex_MatDiffuse;
out vec4 ex_MatAmbient;
out vec4 ex_MatSpecular;
out float ex_MatShininess;

void main()
{
	ex_MatDiffuse = in_MatDiffuse;
	ex_MatAmbient = in_MatAmbient;
	ex_MatSpecular = in_MatSpecular;
	ex_MatShininess = in_MatShininess;

	gl_Position = ProjectionMatrix * ModelViewMatrix * vertex;
}